function initblocks()
	math.randomseed(os.time())
	size = 32
	blocks = {}
	terrainimg = love.graphics.newImage("img/terrain.png")
	block = {
		cstone = love.graphics.newQuad(0, 32, 32, 32, 512, 512),
		stone = love.graphics.newQuad(32, 0, 32, 32, 512, 512),
		dirt = love.graphics.newQuad(64, 0, 32, 32, 512, 512),
		grass = love.graphics.newQuad(96, 0, 32, 32, 512, 512),
		wood = love.graphics.newQuad(128, 32, 32, 32, 512, 512),
		leaves = love.graphics.newQuad(128, 96, 32, 32, 512, 512),
		coal = love.graphics.newQuad(64, 64, 32, 32, 512, 512),
		iron = love.graphics.newQuad(32, 64, 32, 32, 512, 512),
		diamond = love.graphics.newQuad(64, 96, 32, 32, 512, 512),
		woodplanks = love.graphics.newQuad(128, 0, 32, 32, 512, 512)
	}
	canPlace = true
	cBlock = 1
	spawnWorld()
	worldstatus = "idle"
	ut = 0
end

function selectBlock(id)
	if id == 1 then
		return block.cstone
	elseif id == 2 then
		return block.stone
	elseif id == 3 then
		return block.dirt
	elseif id == 4 then
		return block.grass
	elseif id == 5 then
		return block.wood
	elseif id == 6 then
		return block.leaves
	elseif id == 7 then
		return block.coal
	elseif id == 8 then
		return block.iron
	elseif id == 9 then
		return block.diamond
	elseif id == 10 then
		return block.woodplanks
	end
end

function getBlockName(id)
	if id == 1 then
		return "Cobblestone"
	elseif id == 2 then
		return "Stone"
	elseif id == 3 then
		return "Dirt"
	elseif id == 4 then
		return "Grass"
	elseif id == 5 then
		return "Wood"
	elseif id == 6 then
		return "Leaves"
	elseif id == 7 then
		return "Coal"
	elseif id == 8 then
		return "Iron Ore"
	elseif id == 9 then
		return "Diamon Ore"
	elseif id == 10 then
		return "Wooden Planks"
	end
end

function spawnWorld()
	--World Generation
	if #blocks > 0 then
		clearBlocks()
	end
	blockx = -32
	blocky = 160
	worldstatus = "spawning world"
	for i=1, 250 do
		blockx = blockx + 32
		if blockx > 768 then
			blockx = 0
			blocky = blocky + 32
		end
		--Current block
		if i > -1 and i < 26 then
			rnd = math.random(0, 50)
			if rnd > 0 and rnd < 2 then
				cBlock = 3
			elseif rnd > 3 and rnd < 45 then
				cBlock = 4
			elseif rnd > 45 and rnd < 50 then
				cBlock = 0
			end
			addBlock(blockx, blocky, selectBlock(cBlock))
		elseif i > 24 and i < 51 then
			rnd = math.random(0, 50)
			if rnd > 0 and rnd < 3 then
				cBlock = 2
			elseif rnd > 3 and rnd < 50 then
				cBlock = 3
			end
			addBlock(blockx, blocky, selectBlock(cBlock))
		elseif i > 49 and i < 76 then
			rnd = math.random(0, 50)
			if rnd > 0 and rnd < 10 then
				cBlock = 3
			elseif rnd > 10 and rnd < 45 then
				cBlock = 2
			elseif rnd > 45 and rnd < 50 then
				cBlock = 7
			end
			addBlock(blockx, blocky, selectBlock(cBlock))
		elseif i > 75 and i < 201 then
			rnd = math.random(0, 50)
			if rnd > 0 and rnd < 2 then
				cBlock = 7
			elseif rnd > 2 and rnd < 48 then
				cBlock = 2
			elseif rnd > 48 and rnd < 50 then
				cBlock = 8
			end
			addBlock(blockx, blocky, selectBlock(cBlock))
		else
			rnd = math.random(0, 50)
			if rnd > 0 and rnd < 2 then
				cBlock = 9
			elseif rnd > 2 and rnd < 50 then
				cBlock = 2
			end
			addBlock(blockx, blocky, selectBlock(cBlock))
		end
		worldstatus = "idle"
	end
end

function addBlock(x, y, dt)
	if cBlock > 0 then
		blocks[#blocks + 1] = {
			x = math.floor(x / size),
			y = math.floor(y / size),
			t = dt,
			fuckoff = false,
			id = cBlock
		}
	end
end

function removeBlock()
	mx, my = love.mouse.getPosition()
	mx = math.floor(mx / size)
	my = math.floor(my / size)
	for i=1, #blocks do
		if mx == blocks[i].x and my ==  blocks[i].y then
			 blocks[i].fuckoff = true
			 break
		end
	end
end

function clearBlocks()
	for i=#blocks, 1, -1 do
		table.remove(blocks, i)
	end
end

function checkforblock()
	mx, my = love.mouse.getPosition()
	mx = math.floor(mx / size)
	my = math.floor(my / size)
	for i=1, #blocks do
		if mx == blocks[i].x and my == blocks[i].y then
			return false
		end
	end
	return true
end

function updateblocks(dt)
	--ut = ut + dt
	--if ut > 0.1 then
		for i=1, #blocks do
			if blocks[i].fuckoff == true then
				table.remove(blocks, i)
				break
			end
		end
		--ut = 0
	--end
end

function drawblocks()
	for i=1, #blocks do
		if blocks[i].t == block.leaves then
			love.graphics.setColor(0,255,0)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.drawq(terrainimg, blocks[i].t, blocks[i].x * size, blocks[i].y * size)
	end
end

function love.mousepressed(x, y, key)
	if key == "l" then
		if checkforblock() then
			if canPlace then
				addBlock(x, y, selectBlock(cBlock))
			end
		end
	--HUD
	hudMousepress(x, y)
	end
	if key == "r" then
		removeBlock()
	end
	if key == "wu" then
		if cBlock > 9 then
			cBlock = 1
		else
			cBlock = cBlock + 1
		end
	elseif key == "wd" then
		if cBlock < 2 then
			cBlock = 10
		else
			cBlock = cBlock - 1
		end
	end
end













